import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "moebius92.Handlers";

_G.srtload = Turbine.PluginData.Load(Turbine.DataScope.Server, "SkirmishRaidTracker");
if type(_G.srtload) == "string" then
	SkirmishRaids = loadstring("return " .. _G.srtload .. ";")();
elseif type(_G.srtload) ~= "table" then
	SkirmishRaids = { };
end

_G.srtload = Turbine.PluginData.Load(Turbine.DataScope.Server, "WarbandTracker");
if type(_G.srtload) == "string" then
	Warbands = loadstring("return " .. _G.srtload .. ";")();
elseif type(_G.srtload) ~= "table" then
	Warbands = { };
end

moebius92.Handlers.AddChatHandler(
function(m)
	local name = Turbine.Gameplay.LocalPlayer.GetInstance():GetName();

	local x, y, z = string.find(m, "^Completed:%s*(.*) - Raid%s*$");
	if x ~= nil then
		if SkirmishRaids[name] == nil then
			SkirmishRaids[name] = { };
		end
		SkirmishRaids[name][z] = Turbine.Engine.GetLocalTime();
		Turbine.PluginData.Save(Turbine.DataScope.Server, "SkirmishRaidTracker", serialize(SkirmishRaids));
		return;
	end

	local x, y, z = string.find(m, "^Completed:%s*Warband: (.*)%s*$");
	if x ~= nil then
		if Warbands[name] == nil then
			Warbands[name] = { };
		end
		Warbands[name][z] = Turbine.Engine.GetLocalTime();
		Turbine.PluginData.Save(Turbine.DataScope.Server, "WarbandTracker", serialize(Warbands));
		return;
	end
end,
               Turbine.ChatType.Quest, nil);

			   SkirmishRaidTrackerCommand = class(Turbine.ShellCommand);

function SkirmishRaidTrackerCommand:Execute(command, arguments)
	local time = Turbine.Engine.GetDate();
	local sr = math.floor((Turbine.Engine.GetLocalTime() - ((time.IsDST and 10 or 11) * 60 * 60)) / (7 * 24 * 60 * 60));
	local wr = math.floor((Turbine.Engine.GetLocalTime() - ((time.IsDST and 7 or 8) * 60 * 60)) / (24 * 60 * 60));
	local ti = { };
	local t = { };

	for k in pairs(SkirmishRaids) do
		if t[k] == nil then
			table.insert(ti, k);
			t[k] = true;
		end
	end
	for k in pairs(Warbands) do
		if t[k] == nil then
			table.insert(ti, k);
			t[k] = true;
		end
	end
	table.sort(ti);

	for i = 1, #ti, 1 do
		local found = 0;

		if SkirmishRaids[ti[i]] ~= nil then
			local tj = { };

			for k in pairs(SkirmishRaids[ti[i]]) do
				table.insert(tj, k);
			end
			table.sort(tj);

			for j = 1, #tj, 1 do
				local sr1 = math.floor((SkirmishRaids[ti[i]][tj[j]] - ((time.IsDST and 10 or 11) * 60 * 60)) / (7 * 24 * 60 * 60));

				if sr == sr1 then
					if found == 0 then
						Turbine.Shell.WriteLine("");
						Turbine.Shell.WriteLine(ti[i] .. ":");
						found = 1;
					end
					Turbine.Shell.WriteLine(tj[j]);
				end
			end
		end

		if Warbands[ti[i]] ~= nil then
			local tj = { };

			for k in pairs(Warbands[ti[i]]) do
				table.insert(tj, k);
			end
			table.sort(tj);

			for j = 1, #tj, 1 do
				local wr1 = math.floor((Warbands[ti[i]][tj[j]] - ((time.IsDST and 7 or 8) * 60 * 60)) / (24 * 60 * 60));

				if wr == wr1 then
					if found < 2 then
						Turbine.Shell.WriteLine("");
						if found == 0 then
							Turbine.Shell.WriteLine(ti[i] .. ":");
						end
						found = 2;
					end
					Turbine.Shell.WriteLine(tj[j]);
				end
			end
		end
	end
end

function SkirmishRaidTrackerCommand:GetShortHelp()
	return "Skirmish Raid Tracker";
end

plugin.command = SkirmishRaidTrackerCommand();
Turbine.Shell.AddCommand('srt', plugin.command);